/*  Filename: i2cm.c
    Description: I2C master API
    Language: C30(Evaluation Version)
    Target: PIC24FJ64GA002, LCD-SDCARD UNIT
*/

#include <p24FJ64GA002.h>
#include "delay.h"

#define RETRY 100
int i;

void i2c2_init(void){
     AD1PCFG |= (1<<5)|(1<<4);

    //I2C2ɌqĂX[uɋNꍇA
    //}X^[I2C2삵Ȃꍇ̉B
    //PIC24FJ64GA002 bg0830KK1
    TRISBbits.TRISB2 = 0;
    TRISBbits.TRISB3 = 0;
    LATBbits.LATB2 = 0;
    LATBbits.LATB3 = 0;
    delay_ms(100);
    LATBbits.LATB2 = 1;
    LATBbits.LATB3 = 1;
    //􂱂܂

    I2C2BRG = 511; // 33kHz
//  I2C2BRG = 78; // 100kHz
//  I2C2BRG = 18; // 400kHz
    I2C2CON = 0b1000000000000000; // 7bit address
}

void i2c2_idleck(void){
    while(
    (I2C2CON & 0b0000000000011111) | //ACKEN,RCEN,PEN,RSEN,SEN
    I2C2STATbits.TRSTAT //}X^M
    );
}

void i2c2_start(void){
    i2c2_idleck();
    I2C2CONbits.SEN = 1;
}

void i2c2_repstart(void){
    i2c2_idleck();
    I2C2CONbits.RSEN = 1;
}

void i2c2_stop(void){
    i2c2_idleck();
    I2C2CONbits.PEN = 1;
}

/*
unsigned char
i2c2_write(unsigned char d){
    i2c2_idleck();
    I2C2TRN = d;
    i2c2_idleck();
    return(I2C2STATbits.ACKSTAT);
}
*/

unsigned char
i2c2_write(unsigned char d){
    i2c2_idleck();
    IFS3bits.MI2C2IF = 0;
    I2C2TRN = d;
    i2c2_idleck();
    for(i=0; i<RETRY; i++) if(IFS3bits.MI2C2IF) break;
    if(IFS3bits.MI2C2IF==0) return(0xff);//no return ack
    return(I2C2STATbits.ACKSTAT);
}

unsigned char
i2c2_read(unsigned char a){
    unsigned char d;

    i2c2_idleck();
    I2C2CONbits.RCEN = 1;
    i2c2_idleck();
    d = I2C2RCV;
    I2C2CONbits.ACKDT = a;//0:ACK, 1:NACK
    I2C2CONbits.ACKEN = 1;
    return(d);
}

