//: PIC24FJ64GA002
//NbNgp
//RTCgpiOt32.768HztĂj
//̓dqH̕ 2010.1.27

#include <p24FJ64GA002.h>
#include <stdio.h>
#include <string.h>
#include "GenericTypeDefs.h"
#include "delay.h"
#include "rtc.h"
#include "i2cm.h"

#define I2C_NUM_ADR     0x53 //l\u I2C AhX

#define I2C_READ_ACK  0  //I2C read p
#define I2C_READ_NACK 1  //I2C read I
#define I2C_READ  1      //I2C read AhXOR
#define I2C_WRITE 0      //I2C write AhXOR

#define I2C_RETRY 10     //I2C̃AhXMgC
#define I2C_RETRY_MS 100 //I2C̃AhXMgCEC^[omsec


_CONFIG1(
    JTAGEN_OFF &
    GCP_OFF &
    GWRP_OFF &
    BKBUG_OFF &
    COE_OFF &
    ICS_PGx2 &
    FWDTEN_OFF
) 

_CONFIG2(
    IESO_OFF &
    FNOSC_FRCPLL &
    FCKSM_CSDCMD &
    OSCIOFNC_ON &
    IOL1WAY_OFF &
    I2C1SEL_PRI &
    POSCMOD_NONE
)

//l\uo
//n=l, p=_ʒu(4=\,3,2,1,0)
BYTE i2c_num(WORD n, BYTE p)
{
    BYTE i, ack;

    i2c2_start();
    for(i=0;i<I2C_RETRY;i++) {
        ack = i2c2_write((I2C_NUM_ADR << 1) | I2C_WRITE);
        if(ack!=0){
            i2c2_stop();
            delay_ms(I2C_RETRY_MS);
        }
        else break;
    }
    if(ack!=0) return(ack);
    
    i2c2_write(n >> 8);
    i2c2_write(n++ & 0x00ff);
    i2c2_write(p);
    i2c2_stop();
    return(ack);
}

int main(void)
{
    char date[9];
    char time[9];
    int n = 0;
    int sw = 0;

    CLKDIV = 0;//NbNȂ

    i2c2_init();
    rtc_init();

    //RTCZbg
    strcpy(date,"10/01/27");//N
    strcpy(time,"00:00:00");//b
    if(rtc_date_save(date)==0 && rtc_time_save(time)==0){
        rtc_setup();
    }

    sw = 0;

    while(1){

        switch(sw){
        case 0:
            delay_ms(500);
            i2c_num(n, 4);//l\uo
            n++;
            if(n>9999) n = 0;
            break;
        case 1:
            //RTC
            if(rtc_date_update()){
            }

            if(rtc_time_update()){
                 strcpy(time, rtc_time_str());

                 //bɓ
                 n =  (time[3] - 0x30) * 1000;//
                 n += (time[4] - 0x30) * 100; //
                 n += (time[6] - 0x30) * 10;  //b
                 n += (time[7] - 0x30) * 1;   //b

                 i2c_num(n, 2);//l\uo
            }
            break;
        default:
            break;
        }//switch end

    }//while(1) end
}
